import { __extends } from 'tslib';
import { Directive, Component, ViewEncapsulation, ChangeDetectionStrategy, ChangeDetectorRef, Optional, Inject, Input, HostListener, HostBinding, EventEmitter, Output, NgModule } from '@angular/core';
import { MatSort, matSortAnimations, MatSortHeaderIntl, MatSortHeader, MatCommonModule, MatTableModule, MatDividerModule, MatIconModule, MatCheckboxModule, MatMenuModule, MatButtonModule } from '@angular/material';
import { CommonModule } from '@angular/common';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import { FormsModule } from '@angular/forms';
import { Subject, BehaviorSubject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mat-multi-sort.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MatMultiSort = /** @class */ (function (_super) {
    __extends(MatMultiSort, _super);
    function MatMultiSort() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.start = (/** @type {?} */ ('asc'));
        _this.actives = [];
        _this.directions = [];
        return _this;
    }
    /**
     * @return {?}
     */
    MatMultiSort.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        _super.prototype.ngOnInit.call(this);
    };
    /**
     * @param {?} sortable
     * @return {?}
     */
    MatMultiSort.prototype.sort = /**
     * @param {?} sortable
     * @return {?}
     */
    function (sortable) {
        this.updateMultipleSorts(sortable);
        _super.prototype.sort.call(this, sortable);
    };
    /**
     * @param {?} sortable
     * @return {?}
     */
    MatMultiSort.prototype.updateMultipleSorts = /**
     * @param {?} sortable
     * @return {?}
     */
    function (sortable) {
        /** @type {?} */
        var i = this.actives.findIndex((/**
         * @param {?} activeId
         * @return {?}
         */
        function (activeId) { return activeId === sortable.id; }));
        if (this.isActive(sortable)) {
            if (this.activeDirection(sortable) === (sortable.start ? sortable.start : this.start)) {
                this.directions.splice(i, 1, this.getNextSortDirection(sortable));
            }
            else {
                this.actives.splice(i, 1);
                this.directions.splice(i, 1);
            }
        }
        else {
            this.actives.push(sortable.id);
            this.directions.push(sortable.start ? sortable.start : this.start);
        }
    };
    /**
     * @param {?} sortable
     * @return {?}
     */
    MatMultiSort.prototype.isActive = /**
     * @param {?} sortable
     * @return {?}
     */
    function (sortable) {
        /** @type {?} */
        var i = this.actives.findIndex((/**
         * @param {?} activeId
         * @return {?}
         */
        function (activeId) { return activeId === sortable.id; }));
        return i > -1;
    };
    /**
     * @param {?} sortable
     * @return {?}
     */
    MatMultiSort.prototype.activeDirection = /**
     * @param {?} sortable
     * @return {?}
     */
    function (sortable) {
        /** @type {?} */
        var i = this.actives.findIndex((/**
         * @param {?} activeId
         * @return {?}
         */
        function (activeId) { return activeId === sortable.id; }));
        return this.directions[i] || (sortable.start ? sortable.start : this.start);
    };
    MatMultiSort.decorators = [
        { type: Directive, args: [{
                    selector: '[matMultiSort]',
                    exportAs: 'matMultiSort'
                },] }
    ];
    return MatMultiSort;
}(MatSort));
if (false) {
    /** @type {?} */
    MatMultiSort.prototype.start;
    /** @type {?} */
    MatMultiSort.prototype.actives;
    /** @type {?} */
    MatMultiSort.prototype.directions;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mat-multi-sort-header/mat-multi-sort-header.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Column definition associated with a `MatSortHeader`.
 * @record
 */
function C2MatSortHeaderColumnDef() { }
if (false) {
    /** @type {?} */
    C2MatSortHeaderColumnDef.prototype.name;
}
var MatMultiSortHeaderComponent = /** @class */ (function (_super) {
    __extends(MatMultiSortHeaderComponent, _super);
    function MatMultiSortHeaderComponent(_intl, changeDetectorRef, _sort, _columnDef) {
        var _this = _super.call(this, _intl, changeDetectorRef, _sort, _columnDef) || this;
        _this._intl = _intl;
        _this._sort = _sort;
        _this._columnDef = _columnDef;
        _this.start = (/** @type {?} */ ('asc'));
        return _this;
    }
    /**
     * @param {?} visible
     * @return {?}
     */
    MatMultiSortHeaderComponent.prototype.__setIndicatorHintVisible = /**
     * @param {?} visible
     * @return {?}
     */
    function (visible) {
        _super.prototype._setIndicatorHintVisible.call(this, (/** @type {?} */ (visible)));
    };
    /**
     * @return {?}
     */
    MatMultiSortHeaderComponent.prototype._handleClick = /**
     * @return {?}
     */
    function () {
        _super.prototype._handleClick.call(this);
    };
    /**
     * @return {?}
     */
    MatMultiSortHeaderComponent.prototype._isSorted = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this._sort.actives.findIndex((/**
         * @param {?} activeId
         * @return {?}
         */
        function (activeId) { return activeId === _this.id; })) > -1;
    };
    /**
     * @return {?}
     */
    MatMultiSortHeaderComponent.prototype._sortId = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this._sort.actives.findIndex((/**
         * @param {?} activeId
         * @return {?}
         */
        function (activeId) { return activeId === _this.id; })) + 1;
    };
    /**
     * @return {?}
     */
    MatMultiSortHeaderComponent.prototype._updateArrowDirection = /**
     * @return {?}
     */
    function () {
        this._arrowDirection = this.getSortDirection();
    };
    /**
     * @return {?}
     */
    MatMultiSortHeaderComponent.prototype._getAriaSortAttribute = /**
     * @return {?}
     */
    function () {
        if (!this._isSorted()) {
            return null;
        }
        return this.getSortDirection() === 'asc' ? 'ascending' : 'descending';
    };
    /**
     * @return {?}
     */
    MatMultiSortHeaderComponent.prototype._renderArrow = /**
     * @return {?}
     */
    function () {
        return !this._isDisabled() || this._isSorted();
    };
    /**
     * @return {?}
     */
    MatMultiSortHeaderComponent.prototype.getSortDirection = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var i = this._sort.actives.findIndex((/**
         * @param {?} activeIds
         * @return {?}
         */
        function (activeIds) { return activeIds === _this.id; }));
        /** @type {?} */
        var direction = this._sort.directions[i];
        return this._isSorted() ? direction : (this.start || this._sort.start);
    };
    MatMultiSortHeaderComponent.decorators = [
        { type: Component, args: [{
                    selector: '[mat-multi-sort-header]',
                    exportAs: 'matMultiSortHeader',
                    template: "<div class=\"mat-sort-header-container\"\n     [class.mat-sort-header-sorted]=\"_isSorted()\"\n     [class.mat-sort-header-position-before]=\"arrowPosition == 'before'\">\n  <button class=\"mat-sort-header-button\" type=\"button\"\n          [attr.disabled]=\"_isDisabled() || null\"\n          [attr.aria-label]=\"_intl.sortButtonLabel(id)\"\n          (focus)=\"_setIndicatorHintVisible(true)\"\n          (blur)=\"_setIndicatorHintVisible(false)\">\n    <ng-content></ng-content>\n  </button>\n\n  <!-- Disable animations while a current animation is running -->\n  <div class=\"mat-sort-header-arrow\"\n       *ngIf=\"_renderArrow()\"\n       [@arrowOpacity]=\"_getArrowViewState()\"\n       [@arrowPosition]=\"_getArrowViewState()\"\n       [@allowChildren]=\"_getArrowDirectionState()\"\n       (@arrowPosition.start)=\"_disableViewStateAnimation = true\"\n       (@arrowPosition.done)=\"_disableViewStateAnimation = false\">\n    <div class=\"mat-sort-header-stem\"></div>\n    <div class=\"mat-sort-header-indicator\" [@indicator]=\"_getArrowDirectionState()\">\n      <div class=\"mat-sort-header-pointer-left\" [@leftPointer]=\"_getArrowDirectionState()\"></div>\n      <div class=\"mat-sort-header-pointer-right\" [@rightPointer]=\"_getArrowDirectionState()\"></div>\n      <div class=\"mat-sort-header-pointer-middle\"></div>\n    </div>\n  </div>\n  <div *ngIf=\"_isSorted()\">{{_sortId()}}</div>\n</div>\n",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    animations: [
                        matSortAnimations.indicator,
                        matSortAnimations.leftPointer,
                        matSortAnimations.rightPointer,
                        matSortAnimations.arrowOpacity,
                        matSortAnimations.arrowPosition,
                        matSortAnimations.allowChildren
                    ],
                    styles: [".mat-sort-header-container{display:-webkit-box;display:flex;cursor:pointer;-webkit-box-align:center;align-items:center}.mat-sort-header-disabled .mat-sort-header-container{cursor:default}.mat-sort-header-position-before{-webkit-box-orient:horizontal;-webkit-box-direction:reverse;flex-direction:row-reverse}.mat-sort-header-button{border:none;background:0 0;display:-webkit-box;display:flex;-webkit-box-align:center;align-items:center;padding:0;cursor:inherit;outline:0;font:inherit;color:currentColor}.mat-sort-header-button::-moz-focus-inner{border:0}.mat-sort-header-arrow{height:12px;width:12px;min-width:12px;position:relative;display:-webkit-box;display:flex;opacity:0}.mat-sort-header-arrow,[dir=rtl] .mat-sort-header-position-before .mat-sort-header-arrow{margin:0 0 0 6px}.mat-sort-header-position-before .mat-sort-header-arrow,[dir=rtl] .mat-sort-header-arrow{margin:0 6px 0 0}.mat-sort-header-stem{background:currentColor;height:10px;width:2px;margin:auto;display:-webkit-box;display:flex;-webkit-box-align:center;align-items:center}.mat-sort-header-indicator{width:100%;height:2px;display:-webkit-box;display:flex;-webkit-box-align:center;align-items:center;position:absolute;top:0;left:0}.mat-sort-header-pointer-middle{margin:auto;height:2px;width:2px;background:currentColor;-webkit-transform:rotate(45deg);transform:rotate(45deg)}.mat-sort-header-pointer-left,.mat-sort-header-pointer-right{background:currentColor;width:6px;height:2px;position:absolute;top:0}.mat-sort-header-pointer-left{-webkit-transform-origin:right;transform-origin:right;left:0}.mat-sort-header-pointer-right{-webkit-transform-origin:left;transform-origin:left;right:0}"]
                }] }
    ];
    /** @nocollapse */
    MatMultiSortHeaderComponent.ctorParameters = function () { return [
        { type: MatSortHeaderIntl },
        { type: ChangeDetectorRef },
        { type: MatMultiSort, decorators: [{ type: Optional }] },
        { type: undefined, decorators: [{ type: Inject, args: ['C2_SORT_HEADER_COLUMN_DEF',] }, { type: Optional }] }
    ]; };
    MatMultiSortHeaderComponent.propDecorators = {
        id: [{ type: Input, args: ['mat-multi-sort-header',] }],
        __setIndicatorHintVisible: [{ type: HostListener, args: ['mouseenter', ['true'],] }, { type: HostListener, args: ['longpress', ['true'],] }, { type: HostListener, args: ['mouseleave', ['false'],] }],
        _handleClick: [{ type: HostListener, args: ['click',] }],
        _getAriaSortAttribute: [{ type: HostBinding, args: ['attr.aria-sort',] }]
    };
    return MatMultiSortHeaderComponent;
}(MatSortHeader));
if (false) {
    /** @type {?} */
    MatMultiSortHeaderComponent.prototype.start;
    /** @type {?} */
    MatMultiSortHeaderComponent.prototype.id;
    /** @type {?} */
    MatMultiSortHeaderComponent.prototype._intl;
    /** @type {?} */
    MatMultiSortHeaderComponent.prototype._sort;
    /** @type {?} */
    MatMultiSortHeaderComponent.prototype._columnDef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mat-multi-sort-table-settings/mat-multi-sort-table-settings.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MatMultiSortTableSettingsComponent = /** @class */ (function () {
    function MatMultiSortTableSettingsComponent() {
        this.activeColumnsChange = new EventEmitter();
    }
    Object.defineProperty(MatMultiSortTableSettingsComponent.prototype, "columns", {
        set: /**
         * @param {?} columns
         * @return {?}
         */
        function (columns) {
            this._columns = columns.map((/**
             * @param {?} c
             * @return {?}
             */
            function (c) {
                return { id: c.id, name: c.name, pipe: c.pipe ? c.pipe : '', isActive: true };
            }));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} event
     * @return {?}
     */
    MatMultiSortTableSettingsComponent.prototype.drop = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        moveItemInArray(this._columns, event.previousIndex, event.currentIndex);
        this.activeColumnsChange.emit(this._columns.filter((/**
         * @param {?} c
         * @return {?}
         */
        function (c) { return c.isActive; })).map((/**
         * @param {?} c
         * @return {?}
         */
        function (c) { return c.id; })));
    };
    /**
     * @return {?}
     */
    MatMultiSortTableSettingsComponent.prototype.toggle = /**
     * @return {?}
     */
    function () {
        this.activeColumnsChange.emit(this._columns.filter((/**
         * @param {?} c
         * @return {?}
         */
        function (c) { return c.isActive; })).map((/**
         * @param {?} c
         * @return {?}
         */
        function (c) { return c.id; })));
    };
    MatMultiSortTableSettingsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'mat-multi-sort-table-settings',
                    template: "<div class=\"table-settings\">\n    <button mat-stroked-button [matMenuTriggerFor]=\"menu\">\n        Spalten bearbeiten &nbsp;\n        <mat-icon>menu</mat-icon>\n    </button>\n    <mat-menu #menu=\"matMenu\">\n        <div cdkDropList class=\"example-list\" (cdkDropListDropped)=\"drop($event)\">\n            <div class=\"example-box\" *ngFor=\"let column of _columns\" cdkDrag>\n                <mat-icon>drag_indicator</mat-icon>\n                <mat-checkbox [(ngModel)]=\"column.isActive\" (change)=\"toggle()\">{{column.name}}</mat-checkbox>\n            </div>\n        </div>\n    </mat-menu>\n</div>\n<mat-divider></mat-divider>",
                    styles: [".table-settings{display:-webkit-box;display:flex;-webkit-box-pack:end;justify-content:flex-end}.table-settings button{margin:8px 16px}.example-box{height:48px;display:-webkit-box;display:flex;-webkit-box-pack:start;justify-content:flex-start;-webkit-box-align:center;align-items:center;margin:1px;padding:0 16px 0 8px}.example-box mat-icon{margin-right:16px}.example-box mat-checkbox{line-height:48px;color:rgba(0,0,0,.87);font-size:14px;font-weight:400}.example-box:hover{cursor:move;border-top:1px solid rgba(0,0,0,.12);border-bottom:1px solid rgba(0,0,0,.12)}.my-menu:hover{cursor:move}.cdk-drag-preview{box-sizing:border-box;border-radius:4px;box-shadow:0 5px 5px -3px rgba(0,0,0,.2),0 8px 10px 1px rgba(0,0,0,.14),0 3px 14px 2px rgba(0,0,0,.12)}.cdk-drag-placeholder{opacity:0}.cdk-drag-animating{-webkit-transition:-webkit-transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}.example-box:last-child{border:none}.example-list.cdk-drop-list-dragging .example-box:not(.cdk-drag-placeholder){-webkit-transition:-webkit-transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1)}"]
                }] }
    ];
    /** @nocollapse */
    MatMultiSortTableSettingsComponent.ctorParameters = function () { return []; };
    MatMultiSortTableSettingsComponent.propDecorators = {
        columns: [{ type: Input }],
        activeColumnsChange: [{ type: Output }]
    };
    return MatMultiSortTableSettingsComponent;
}());
if (false) {
    /** @type {?} */
    MatMultiSortTableSettingsComponent.prototype._columns;
    /** @type {?} */
    MatMultiSortTableSettingsComponent.prototype.activeColumnsChange;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mat-multi-sort.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MatMultiSortModule = /** @class */ (function () {
    function MatMultiSortModule() {
    }
    MatMultiSortModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [MatMultiSortHeaderComponent, MatMultiSort, MatMultiSortTableSettingsComponent],
                    exports: [MatMultiSortHeaderComponent, MatMultiSort, MatMultiSortTableSettingsComponent],
                    imports: [
                        CommonModule,
                        MatCommonModule,
                        MatTableModule,
                        MatDividerModule,
                        DragDropModule,
                        MatIconModule,
                        MatCheckboxModule,
                        MatMenuModule,
                        MatButtonModule,
                        FormsModule
                    ]
                },] }
    ];
    return MatMultiSortModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/table-data.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var  /**
 * @template T
 */
TableData = /** @class */ (function () {
    // TODO refactor
    function TableData(columns, totalElements, options) {
        this.nextObservable = new Subject();
        this.previousObservable = new Subject();
        this.sizeObservable = new Subject();
        this.sortObservable = new Subject();
        this.totalElements = totalElements;
        this.columns = columns;
        this.displayedColumns = this.columns.map((/**
         * @param {?} c
         * @return {?}
         */
        function (c) { return c.id; }));
        if (options) {
            this.sortParams = options.defaultSortParams || [];
            this.sortDirs = options.defaultSortDirs || [];
            if (options.pageSizeOptions && options.pageSizeOptions.length > 1) {
                throw Error('Array of pageSizeOptions must contain at least one entry');
            }
            this.pageSizeOptions = options.pageSizeOptions;
        }
        else {
            this.pageSizeOptions = [10, 20, 50, 100];
        }
        this.pageSize = this.pageSizeOptions[0];
    }
    /**
     * @return {?}
     */
    TableData.prototype.onSortEvent = /**
     * @return {?}
     */
    function () {
        this.sortParams = this.dataSource.sort['actives'];
        this.sortDirs = this.dataSource.sort['directions'];
        this.sortObservable.next();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    TableData.prototype.onPagnationEvent = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        /** @type {?} */
        var tmpPageSize = this.pageSize;
        this.pageSize = $event.pageSize;
        this.pageIndex = $event.pageIndex;
        if (tmpPageSize !== this.pageSize) {
            this.sizeObservable.next();
        }
        else if ($event.previousPageIndex < $event.pageIndex) {
            this.nextObservable.next();
        }
        else if ($event.previousPageIndex > $event.pageIndex) {
            this.previousObservable.next();
        }
    };
    /**
     * @param {?} columns
     * @return {?}
     */
    TableData.prototype.setDisplayedColumns = /**
     * @param {?} columns
     * @return {?}
     */
    function (columns) {
        this.displayedColumns = columns;
    };
    return TableData;
}());
if (false) {
    /** @type {?} */
    TableData.prototype.dataSource;
    /** @type {?} */
    TableData.prototype.columns;
    /** @type {?} */
    TableData.prototype.displayedColumns;
    /** @type {?} */
    TableData.prototype.pageSize;
    /** @type {?} */
    TableData.prototype.pageIndex;
    /** @type {?} */
    TableData.prototype.pageSizeOptions;
    /** @type {?} */
    TableData.prototype.totalElements;
    /** @type {?} */
    TableData.prototype.sortParams;
    /** @type {?} */
    TableData.prototype.sortDirs;
    /** @type {?} */
    TableData.prototype.nextObservable;
    /** @type {?} */
    TableData.prototype.previousObservable;
    /** @type {?} */
    TableData.prototype.sizeObservable;
    /** @type {?} */
    TableData.prototype.sortObservable;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/mat-multi-sort-data-source.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var  /**
 * @template T
 */
MatMultiSortTableDataSource = /** @class */ (function () {
    function MatMultiSortTableDataSource(sort, enableClientSideSorting) {
        if (enableClientSideSorting === void 0) { enableClientSideSorting = false; }
        this.tableDataSubject = new BehaviorSubject([]);
        this.tableData = [];
        this.sort = sort;
        this.enableClientSideSorting = enableClientSideSorting;
    }
    /**
     * @param {?} data
     * @return {?}
     */
    MatMultiSortTableDataSource.prototype.setTableData = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.tableData = Object.assign([], data);
        this.tableDataSubject.next(this.tableData);
    };
    /**
     * @return {?}
     */
    MatMultiSortTableDataSource.prototype.connect = /**
     * @return {?}
     */
    function () {
        return this.tableDataSubject;
    };
    /**
     * @return {?}
     */
    MatMultiSortTableDataSource.prototype.disconnect = /**
     * @return {?}
     */
    function () {
        this.tableDataSubject.complete();
    };
    /**
     * @param {?} data
     * @param {?} sort
     * @return {?}
     */
    MatMultiSortTableDataSource.prototype.sortData = /**
     * @param {?} data
     * @param {?} sort
     * @return {?}
     */
    function (data, sort) {
        var _this = this;
        console.log('Sorting');
        if (this.enableClientSideSorting) {
            return data.sort((/**
             * @param {?} i1
             * @param {?} i2
             * @return {?}
             */
            function (i1, i2) {
                return _this._sortData(i1, i2, sort.actives, sort.directions);
            }));
        }
        return this.tableData;
    };
    /**
     * @param {?} d1
     * @param {?} d2
     * @param {?} params
     * @param {?} dirs
     * @return {?}
     */
    MatMultiSortTableDataSource.prototype._sortData = /**
     * @param {?} d1
     * @param {?} d2
     * @param {?} params
     * @param {?} dirs
     * @return {?}
     */
    function (d1, d2, params, dirs) {
        console.log('Sorting data');
        if (d1[params[0]] > d2[params[0]]) {
            return dirs[0] === 'asc' ? 1 : -1;
        }
        else if (d1[params[0]] > d2[params[0]]) {
            return dirs[0] === 'asc' ? -1 : 1;
        }
        else {
            if (params.length > 1) {
                params = params.slice(1, params.length);
                dirs = dirs.slice(1, dirs.length);
                return this._sortData(d1, d2, params, dirs);
            }
            else {
                return 0;
            }
        }
    };
    return MatMultiSortTableDataSource;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    MatMultiSortTableDataSource.prototype.tableDataSubject;
    /**
     * @type {?}
     * @private
     */
    MatMultiSortTableDataSource.prototype.tableData;
    /**
     * @type {?}
     * @private
     */
    MatMultiSortTableDataSource.prototype.enableClientSideSorting;
    /** @type {?} */
    MatMultiSortTableDataSource.prototype.sort;
}

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: mat-multi-sort.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { MatMultiSort, MatMultiSortHeaderComponent, MatMultiSortModule, MatMultiSortTableDataSource, TableData, MatMultiSortTableSettingsComponent as ɵa };
//# sourceMappingURL=mat-multi-sort.js.map
