import { PageEvent } from '@angular/material';
import { Subject } from 'rxjs';
import { MatMultiSortTableDataSource } from './mat-multi-sort-data-source';
export declare class TableData<T> {
    dataSource: MatMultiSortTableDataSource<T>;
    columns: {
        id: string;
        name: string;
    }[];
    displayedColumns: string[];
    pageSize: number;
    pageIndex: number;
    pageSizeOptions: number[];
    totalElements: number;
    sortParams: string[];
    sortDirs: string[];
    nextObservable: Subject<any>;
    previousObservable: Subject<any>;
    sizeObservable: Subject<any>;
    sortObservable: Subject<void>;
    constructor(columns: {
        id: string;
        name: string;
    }[], totalElements: number, options?: {
        defaultSortParams?: string[];
        defaultSortDirs?: string[];
        pageSizeOptions: number[];
    });
    onSortEvent(): void;
    onPagnationEvent($event: PageEvent): void;
    setDisplayedColumns(columns: string[]): void;
}
